var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var beforeCreateForChildrenCollection_exports = {};
__export(beforeCreateForChildrenCollection_exports, {
  beforeCreateForChildrenCollection: () => beforeCreateForChildrenCollection
});
module.exports = __toCommonJS(beforeCreateForChildrenCollection_exports);
function beforeCreateForChildrenCollection(db) {
  return async (model, { transaction, context }) => {
    const Collection = db.getCollection("collections");
    const Field = db.getCollection("fields");
    const parentKey = model.get("parentKey");
    if (!parentKey) {
      return;
    }
    const parent = await Field.model.findByPk(parentKey, { transaction });
    const parentTarget = parent.get("target");
    model.set("collectionName", parentTarget);
    const collection = await Collection.model.findOne({
      transaction,
      where: {
        name: parentTarget
      }
    });
    if (!collection) {
      await Collection.repository.create({
        values: {
          name: parentTarget,
          createdBy: true,
          updatedBy: true,
          sortable: true,
          inherit: true
        },
        transaction,
        context
      });
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  beforeCreateForChildrenCollection
});
